@()(implicit i18nMessages: Messages)

@import play.i18n._
<div class="show-grid call-control calls-outside-header">
    <meetingrooms-invite-displayer></meetingrooms-invite-displayer>
    <table class="table table-no-margin">
        <tbody>
            <tr ng-repeat-start="call in ctrl.calls" class='table-row-call tr-call-hoverable' ng-if="!ctrl.conference.active" ng-class="{'idle': call.state === 'OnHold', 'conference': call.conference}">
                <td class="call-row-wrapper">
                <div class="call-state call-row-element" ng-class="{'extended': ctrl.isWebRtcActive()}">
                    <span class="volume-state" ng-if="ctrl.isWebRtcActive()" ng-click="ctrl.toggleMicrophone(call)">
                        <volume-meter sip-call-id="{{call.userData.SIPCALLID}}" call-state="call.state" show="call.state=='Established'" is-muted="ctrl.isConferenceAndIsMuted(call.uniqueId) || ctrl.isMuted"></volume-meter>
                    </span>
                    <span ng-if="ctrl.isWebRtcActive() && call.state === 'OnHold'" ng-class="[ctrl.faClassFromState(call.state), ctrl.audioQualityClass(), {'idle': call.state === 'OnHold'}]">
                    </span>
                </div>
                <div class="call-name call-row-element" ng-class="{'idle': call.state === 'OnHold'}">
                    <span class="call-party-name call-wrapped-name" ng-if="!call.conference">                        
                        {{(call.otherDName && call.otherDName !== call.otherDN) ? call.otherDName + ' ' + call.otherDN : call.otherDN}}
                    </span>
                    <span ng-if="call.conference" class="conference-name">
                        {{call.conference.conferenceName}} {{call.conference.conferenceNumber}}
                    </span>
                    <span ng-if="call.conference && call.conference.participants.length==1" class="conference-participant-count">
                        @i18nMessages("phonebar.conference_one_participant")
                    </span>
                    <span ng-if="call.conference && call.conference.participants.length>1" class="conference-participant-count">
                        {{call.conference.participants.length}} @i18nMessages("phonebar.conference_participant_count")
                    </span>
                </div>
                <div class="call-duration-actions call-row-element">
                    
                    <span class ="call-duration" ng-if="!call.conference" elapsed-time-from="call.startTime"></span>
                    <span class ="call-duration" ng-if="call.conference" elapsed-time-from="call.conference.startTime"></span>
                    <div class="call-actions">
                        
                        <a class="call-keyboard" ng-if="call.state === 'Established' && ctrl.isWebRtcActive()"
                         href ng-click="ctrl.showKeyboard()" ng-init="variant='default'" ng-mouseover="variant='over'" ng-mouseout="variant='default'"
                         title="@i18nMessages("phoneKeyboard.showKeyboard")">
                            <i class="xivo-clavier-bloc-appel"></i>
                        </a>
                        <a class="chat-bubble" ng-if="ctrl.canChat(call, call.username) && ctrl.appConfig.chat"
                        ui-sref="interface.conversation({remoteParty: call.username})"
                        title="{{'CHAT' | translate}}">
                            <i class="xivo-message"></i>
                        </a>
                        <a class="call-hold" href ng-click="ctrl.hold(call.uniqueId)" ng-if="call.state === 'OnHold' && (ctrl.calls.length === 1 || ctrl.isWebRtcActive())" title="@i18nMessages("phonebar.unhold")">
                                <i class="xivo-play" aria-hidden="true"></i>
                        </a>
                        <a class="call-hold" href ng-click="ctrl.hold(call.uniqueId)" ng-if="call.state === 'Established' && (ctrl.calls.length === 1 || ctrl.isWebRtcActive())" title="@i18nMessages("phonebar.hold")">
                                <i class="xivo-pause-appel" aria-hidden="true"></i>
                        </a>
                        <a class="call-includeToConference" href ng-click="ctrl.includeCallToConference()" ng-if="call.state === 'OnHold' && ctrl.displayIncludeCallToConferenceButton()" title="@i18nMessages("phonebar.includeCallToConference")">
                            <i class="xivo-include-call-to-conference" aria-hidden="true"></i>
                        </a>     
                        <a class="call-conference" href ng-click="ctrl.makeConference()" ng-if="ctrl.displayMakeConferenceButton() && call.state === 'OnHold'" title="@i18nMessages("phonebar.conference")">
                            <i class="fa fa-compress" aria-hidden="true"></i>
                        </a>
                        <a class="call-transfer" href ng-click="ctrl.transfer()" ng-if="ctrl.displayTransferButton() && call.state === 'OnHold' && !isWebRtcActive()" title="@i18nMessages("phonebar.attended_transfer")">
                            <i class="fa fa-share" aria-hidden="true"></i>
                        </a>
                        <a class="call-transfer" href ng-click="ctrl.transfer()" ng-if="ctrl.displayTransferButton() && call.state === 'OnHold' && isWebRtcActive()" title="@i18nMessages("phonebar.complete_transfer")">
                            <i class="fa fa-share" aria-hidden="true"></i>
                        </a>
                        <a class="webrtc-user-mute" href ng-click="ctrl.toggleMicrophone(call)" ng-if="ctrl.muteWebRtcUser(call) && !ctrl.isMuted" title="@i18nMessages("phonebar.mute")">
                                <i class="xivo-micro"></i>
                        </a>
                        <a class="webrtc-user-mute" href ng-click="ctrl.toggleMicrophone(call)" ng-if="ctrl.muteWebRtcUser(call) && ctrl.isMuted" title="@i18nMessages("phonebar.unmute")">
                                <i class="xivo-micro-ferme"></i>
                        </a>
                       
                        <a class="conference-mute-all" href ng-click="ctrl.conferenceMuteAll(call.conference.conferenceNumber)" ng-if="call.conference && ctrl.canMuteAll(call.conference)" title="@i18nMessages("phonebar.mute_all")">
                            <i class="xivo-micro"></i>
                        </a>
                        <a class="conference-unmute-all" href ng-click="ctrl.conferenceUnmuteAll(call.conference.conferenceNumber)" ng-if="call.conference && ctrl.canUnmuteAll(call.conference)" title="@i18nMessages("phonebar.unmute_all")">
                            <i class="xivo-micro-ferme"></i>
                        </a>
                        <a class="call-answer" href ng-click="ctrl.answer(call.uniqueId)" ng-if="call.state === 'Ringing' && !ctrl.isSecondCallAndIsYealink()"  title="@i18nMessages("phonebar.answer")">
                            <i class="xivo-telephone" aria-hidden="true"></i>        
                        </a>

                        <a class="call-hangup"
                           href ng-click="ctrl.hangup(call.uniqueId)" ng-if="call.state === 'Established' || (call.state === 'Ringing') || call.state === 'Dialing'"
                           title="@i18nMessages("phonebar.hangup")">
                           <i class="xivo-raccrocher-3"></i>
                        </a>                        
                    </div>
                </div>
            </td>
            </tr>
            <tr class='table-row-confcall' ng-repeat="participant in call.conference.participants | orderBy:['-isMe', 'callerIdName']" ng-if="call.conference" ng-class="{'idle': call.state === 'OnHold', 'participants': call.conference,'last-participant': $last}">
                <td colspan="3" class="no-padding">
                    <table class="table-no-margin no-border">
                        <tbody class="no-border">  
                            <tr ng-class="{'kicked': participant.kicked}">    
                                <div class="conference-row-wrapper role-{{participant.role | lowercase}}">
                                    <div class="conference-status-wrapper">
                                        <div class="conference-participant-muted" ng-if="participant.isMuted">
                                            <i class="xivo-micro-ferme participant-muted"></i> 
                                        </div>
                                        <div ng-if="participant.isDeaf" class="conference-participant-deaf">
                                            <i class="xivo-deaf"></i>
                                        </div>
                                    </div>
                                    <div class="call-name" title="{{'CONFERENCE_' + participant.role | uppercase | translate}}">   
                                            <span class="call-party-name">{{participant.callerIdName}} {{participant.callerIdNum}}</span>
                                        <i class="fa fa-volume-up participant-speaking" ng-class="{'inactive': !participant.isTalking}"></i>
                                    </div>
                                    
                                    <div class="call-duration-actions">
                                        <span class="call-duration" elapsed-time-from="participant.startTime"></span>
                    
                                        <div class="call-actions" ng-if="!ctrl.displayParticipantActions(call.conference, participant)">
                                            <a class="chat-bubble" ng-if="ctrl.canChat(call, participant.username) && ctrl.appConfig.chat"
                                            ui-sref="interface.conversation({remoteParty: participant.username})"
                                            title="{{'CHAT' | translate}}">
                                                <i class="xivo-message"></i>
                                            </a>         
                                        </div>
                                        
                                        <div class="call-actions" ng-if="ctrl.displayParticipantActions(call.conference, participant)">
                                            <div ng-if="call.conference.currentUserRole == 'User'">
                                                <a class="participant-mute-me" href ng-click="ctrl.conferenceMuteMe(call.conference.conferenceNumber)" ng-if="participant.isMe && !participant.isMuted" title="@i18nMessages("phonebar.mute")">
                                                        <i class="xivo-micro"></i>
                                                </a>
                                                <a class="participant-mute-me" href ng-click="ctrl.conferenceUnmuteMe(call.conference.conferenceNumber)" ng-if="participant.isMe && participant.isMuted" title="@i18nMessages("phonebar.unmute")">
                                                        <i class="xivo-micro-ferme"></i>
                                                </a>
                                            </div>
                                            <div class="managed-conferences" ng-if="call.conference.currentUserRole == 'Organizer'">
                                                <a class="call-hangup hangup-participants"
                                                ng-if="participant.role != 'Organizer'"
                                                href ng-click="ctrl.conferenceKick(call.conference.conferenceNumber, participant)"
                                                title="@i18nMessages("phonebar.conference_kick")">
                                                <i class="xivo-kick"></i>
                                                </a>
                                                <a class="participant-mute-me" href ng-click="ctrl.conferenceMute(call.conference.conferenceNumber, participant.index)" ng-if="!participant.isMuted" title="@i18nMessages("phonebar.mute")">
                                                        <i class="xivo-micro"></i>
                                                </a>
                                                <a class="participant-mute-me" href ng-click="ctrl.conferenceUnmute(call.conference.conferenceNumber, participant.index)" ng-if="participant.isMuted" title="@i18nMessages("phonebar.unmute")">
                                                        <i class="xivo-micro-ferme"></i>
                                                  
                                                </a>
                                            </div>
                                            <div ng-if="!participant.isMe">
                                                    <a class="chat-bubble" ng-if="ctrl.canChat(call, participant.username) && ctrl.appConfig.chat"
                                                    ui-sref="interface.conversation({remoteParty: participant.username})" title="{{'CHAT' | translate}}">
                                                        <i class="xivo-message"></i>
                                                    </a> 
                                            </div>
                                            <a title="{{'UNDEAF_ACTION' | translate}}" ng-if="participant.isDeaf && call.conference.currentUserRole == 'Organizer'" ng-click="ctrl.conferenceUndeaf(call.conference.conferenceNumber, participant.index)" 
                                            class="conference-participant-undeaf">
                                                <i class="xivo-undeaf"></i>
                                            </a>
                                        </div>
                                    </div> 
                                </div>
                            </tr>
                        </tbody>
                    </table>
                </td>
            </tr>
            
            <tr ng-repeat-end ng-if="ctrl.conference.active" class="RTCconference" ng-class="{'idle': call.state === 'OnHold'}">
                <div class="rtc-conference-wrapper" ng-if="ctrl.conference.active">
                    <div class="call-state call-row-element">
                        <i class="xivo-play" aria-hidden="true"></i>
                    </div>
                    <div class="call-name call-row-element">@i18nMessages("phonebar.conference")</div>
                    <div class="call-duration-actions call-row-element">
                        <span class="call-duration" elapsed-time-from="ctrl.conference.startTime"></span>
                        <div class="call-actions">
                            <a class="call-hold" href ng-click="ctrl.hold()">
                                <i class="xivo-pause-appel" aria-hidden="true"></i>
                            </a>
                            <a class="call-hangup" 
                            href ng-click="ctrl.hangup()">
                                <i class="xivo-raccrocher-3"></i>
                            </a>
                        </div>
                    </div>
                </div>
            </tr>
            <tr ng-repeat="call in ctrl.calls" class="RTCconference table-row-confcall"  ng-class="{'idle': call.state === 'OnHold', 'last-participant': $last}">
                <td class="rtc-conference-member-wrapper"  ng-if="ctrl.conference.active">
                    <div class="call-state">
                        <i class="fa fa-compress" aria-hidden="true"></i>
                    </div>
                    <div class="call-name">
                        {{(call.otherDName && call.otherDName !== call.otherDN) ? call.otherDName + ' ' + call.otherDN : call.otherDN}}
                    </div>
                    <span class="call-duration" elapsed-time-from="call.startTime"></span>
              </td>
            </tr>
            <tr class="call-row-wrapper tr-call-placeholder" ng-if="ctrl.callPlaceholderDisplayed">
                <td class="call-placeholder-spinner">
                    <i class="fa fa-spinner fa-pulse fa-fw"></i>
                </td>
                <td class="call-placeholder-msg">{{ 'INIT_CALL' | translate}}</td>
            </tr>
            <tr ng-if="ctrl.displayCallInitError()" class="init-error-message">
                <td><span>{{ 'INIT_CALL_ERROR' | translate : ctrl.dynamicTranslation }}</span><a ng-click="ctrl.closeCallInitError()">X</a></td>
            </tr>
            <tr ng-if="ctrl.videoInitError" class="init-error-message">
                <td><span>{{ ctrl.videoInitError | translate }}</span><a ng-click="ctrl.closeVideoInitError()">X</a></td>
            </tr>
            <tr ng-if="ctrl.displayAudioQualityIssue()" class="audio-quality-message">
                <td><audio-stats-displayer statistics="ctrl.statistics"></audio-stats-displayer></td>
            </tr>
            <tr ng-if="ctrl.displayMicrophoneError()" class="microphone-broken-message">
                <td><span>{{ 'MIC_IS_BROKEN' | translate}}</span><a ng-click="ctrl.disableMicrophoneError()">X</a></td>
            </tr>
        </tbody>
    </table>
</div>
